﻿<?php
/**
 * Plugin Firefox search plugin: Add DokuWiki to Firefox search engine list.
 *
 * @license    GPL 2 (http://www.gnu.org/licenses/gpl.html)
 * @author    Alexander Sorkin aka Kibi <kibizoid@gmail.com>
 */
if(!defined('DOKU_INC')) die();
if(!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN',DOKU_INC.'lib/plugins/');
require_once(DOKU_PLUGIN.'syntax.php');

if(!defined('DOKU_FIREFOX')) define('DOKU_FIREFOX',DOKU_URL.'lib/plugins/firefox/');
 
/**
 * All DokuWiki plugins to extend the parser/rendering mechanism
 * need to inherit from this class
 */
class syntax_plugin_firefox extends DokuWiki_Syntax_Plugin {
 
  var $full_path = DOKU_FIREFOX;

  /**
     * return some info
     */
    function getInfo(){
        return array(
                'author' => 'Alexander Sorkin aka Kibi',
                'email'  => 'kibizoid@gmail.com',
                'date'   => '2006-11-19',
                'name'   => 'Firefox search plugin',
                'desc'   => 'Add DokuWiki to Firefox search engine list. Syntax: [[firefox>text for visitors]]',
                'url'    => 'http://wiki.splitbrain.org/wiki:plugins',
                );
    }


 /**
     * What kind of syntax are we?
     */
    function getType(){ return 'container'; }
    function getPType(){ return 'normal'; }
    function getAllowedTypes() { 
        return array('container','substition','protected','disabled','formatting','paragraphs');
    }

    function getSort(){ return 299; }
 
    function connectTo($mode) {
        $this->Lexer->addEntryPattern('<firefox>(?=.*?</firefox>)',$mode,'plugin_firefox');
    }
    function postConnect() {
        $this->Lexer->addExitPattern('</firefox>','plugin_firefox');
    }
 
 /**
     * Handle the match
     */
    function handle($match, $state, $pos, &$handler){

        return array($state, $match);
    }

 /**
     * Create output
     */
    function render($mode, &$renderer, $indata) {

		if($mode == 'xhtml'){

          list($state, $data) = $indata;

          switch ($state) {
            case DOKU_LEXER_ENTER :
              $renderer->doc .= '<a href="javascript:if ((typeof window.sidebar == \'object\') && (typeof window.sidebar.addSearchEngine == \'function\')) {window.sidebar.addSearchEngine(\''.$this->full_path.'add_dokuwiki.src\', \''.$this->full_path.'add_dokuwiki.png\', \'DokuWiki\', \'png\');}  else {alert(\'Netscape 6 or Mozilla is needed to install a sherlock plugin\')}">';
              break;
  
            case DOKU_LEXER_UNMATCHED :
              $renderer->doc .= $renderer->_xmlEntities($data);
              break;
  
            case DOKU_LEXER_EXIT :
              $renderer->doc .= '</a>';
              break;
          }
          return true;
        }
        
        // unsupported $mode
        return false;
    } 

}
?>